<a id="mypy-boto3-globalaccelerator"></a>

# mypy-boto3-globalaccelerator

[![PyPI - mypy-boto3-globalaccelerator](https://img.shields.io/pypi/v/mypy-boto3-globalaccelerator.svg?color=blue)](https://pypi.org/project/mypy-boto3-globalaccelerator)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-globalaccelerator.svg?color=blue)](https://pypi.org/project/mypy-boto3-globalaccelerator)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-globalaccelerator?color=blue)](https://pypistats.org/packages/mypy-boto3-globalaccelerator)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.GlobalAccelerator 1.17.97](https://boto3.amazonaws.com/v1/documentation/api/1.17.97/reference/services/globalaccelerator.html#GlobalAccelerator)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.18.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-globalaccelerator docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_globalaccelerator/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-globalaccelerator](#mypy-boto3-globalaccelerator)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `GlobalAccelerator` service.

```bash
python -m pip install boto3-stubs[globalaccelerator]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[globalaccelerator]` in your environment:
  `python -m pip install 'boto3-stubs[globalaccelerator]'`

Both type checking and auto-complete should work for `GlobalAccelerator`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[globalaccelerator]` in your environment:
  `python -m pip install 'boto3-stubs[globalaccelerator]'`

Both type checking and auto-complete should work for `GlobalAccelerator`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[globalaccelerator]` in your environment:
  `python -m pip install 'boto3-stubs[globalaccelerator]'`
- Run `mypy` as usual

Type checking should work for `GlobalAccelerator` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[globalaccelerator]` in your environment:
  `python -m pip install 'boto3-stubs[globalaccelerator]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `GlobalAccelerator` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`GlobalAcceleratorClient` provides annotations for
`boto3.client("globalaccelerator")`.

```python
import boto3

from mypy_boto3_globalaccelerator import GlobalAcceleratorClient

client: GlobalAcceleratorClient = boto3.client("globalaccelerator")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: GlobalAcceleratorClient = session.client("globalaccelerator")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_globalaccelerator.paginator` module contains type annotations for
all paginators.

```python
from mypy_boto3_globalaccelerator import GlobalAcceleratorClient
from mypy_boto3_globalaccelerator.paginator import (
    ListAcceleratorsPaginator,
    ListByoipCidrsPaginator,
    ListCustomRoutingAcceleratorsPaginator,
    ListCustomRoutingListenersPaginator,
    ListCustomRoutingPortMappingsPaginator,
    ListCustomRoutingPortMappingsByDestinationPaginator,
    ListEndpointGroupsPaginator,
    ListListenersPaginator,
)

client: GlobalAcceleratorClient = boto3.client("globalaccelerator")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_accelerators_paginator: ListAcceleratorsPaginator = client.get_paginator("list_accelerators")
list_byoip_cidrs_paginator: ListByoipCidrsPaginator = client.get_paginator("list_byoip_cidrs")
list_custom_routing_accelerators_paginator: ListCustomRoutingAcceleratorsPaginator = client.get_paginator("list_custom_routing_accelerators")
list_custom_routing_listeners_paginator: ListCustomRoutingListenersPaginator = client.get_paginator("list_custom_routing_listeners")
list_custom_routing_port_mappings_paginator: ListCustomRoutingPortMappingsPaginator = client.get_paginator("list_custom_routing_port_mappings")
list_custom_routing_port_mappings_by_destination_paginator: ListCustomRoutingPortMappingsByDestinationPaginator = client.get_paginator("list_custom_routing_port_mappings_by_destination")
list_endpoint_groups_paginator: ListEndpointGroupsPaginator = client.get_paginator("list_endpoint_groups")
list_listeners_paginator: ListListenersPaginator = client.get_paginator("list_listeners")
```

<a id="literals"></a>

### Literals

`mypy_boto3_globalaccelerator.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_globalaccelerator.literals import (
    AcceleratorStatusType,
    ByoipCidrStateType,
    ClientAffinityType,
    CustomRoutingAcceleratorStatusType,
    CustomRoutingDestinationTrafficStateType,
    CustomRoutingProtocolType,
    HealthCheckProtocolType,
    HealthStateType,
    IpAddressTypeType,
    ListAcceleratorsPaginatorName,
    ListByoipCidrsPaginatorName,
    ListCustomRoutingAcceleratorsPaginatorName,
    ListCustomRoutingListenersPaginatorName,
    ListCustomRoutingPortMappingsByDestinationPaginatorName,
    ListCustomRoutingPortMappingsPaginatorName,
    ListEndpointGroupsPaginatorName,
    ListListenersPaginatorName,
    ProtocolType,
)

def check_value(value: AcceleratorStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_globalaccelerator.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_globalaccelerator.type_defs import (
    AcceleratorAttributesTypeDef,
    AcceleratorTypeDef,
    AddCustomRoutingEndpointsResponseTypeDef,
    AdvertiseByoipCidrResponseTypeDef,
    ByoipCidrEventTypeDef,
    ByoipCidrTypeDef,
    CidrAuthorizationContextTypeDef,
    CreateAcceleratorResponseTypeDef,
    CreateCustomRoutingAcceleratorResponseTypeDef,
    CreateCustomRoutingEndpointGroupResponseTypeDef,
    CreateCustomRoutingListenerResponseTypeDef,
    CreateEndpointGroupResponseTypeDef,
    CreateListenerResponseTypeDef,
    CustomRoutingAcceleratorAttributesTypeDef,
    CustomRoutingAcceleratorTypeDef,
    CustomRoutingDestinationConfigurationTypeDef,
    CustomRoutingDestinationDescriptionTypeDef,
    CustomRoutingEndpointConfigurationTypeDef,
    CustomRoutingEndpointDescriptionTypeDef,
    CustomRoutingEndpointGroupTypeDef,
    CustomRoutingListenerTypeDef,
    DeprovisionByoipCidrResponseTypeDef,
    DescribeAcceleratorAttributesResponseTypeDef,
    DescribeAcceleratorResponseTypeDef,
    DescribeCustomRoutingAcceleratorAttributesResponseTypeDef,
    DescribeCustomRoutingAcceleratorResponseTypeDef,
    DescribeCustomRoutingEndpointGroupResponseTypeDef,
    DescribeCustomRoutingListenerResponseTypeDef,
    DescribeEndpointGroupResponseTypeDef,
    DescribeListenerResponseTypeDef,
    DestinationPortMappingTypeDef,
    EndpointConfigurationTypeDef,
    EndpointDescriptionTypeDef,
    EndpointGroupTypeDef,
    IpSetTypeDef,
    ListAcceleratorsResponseTypeDef,
    ListByoipCidrsResponseTypeDef,
    ListCustomRoutingAcceleratorsResponseTypeDef,
    ListCustomRoutingEndpointGroupsResponseTypeDef,
    ListCustomRoutingListenersResponseTypeDef,
    ListCustomRoutingPortMappingsByDestinationResponseTypeDef,
    ListCustomRoutingPortMappingsResponseTypeDef,
    ListEndpointGroupsResponseTypeDef,
    ListListenersResponseTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListenerTypeDef,
    PaginatorConfigTypeDef,
    PortMappingTypeDef,
    PortOverrideTypeDef,
    PortRangeTypeDef,
    ProvisionByoipCidrResponseTypeDef,
    SocketAddressTypeDef,
    TagTypeDef,
    UpdateAcceleratorAttributesResponseTypeDef,
    UpdateAcceleratorResponseTypeDef,
    UpdateCustomRoutingAcceleratorAttributesResponseTypeDef,
    UpdateCustomRoutingAcceleratorResponseTypeDef,
    UpdateCustomRoutingListenerResponseTypeDef,
    UpdateEndpointGroupResponseTypeDef,
    UpdateListenerResponseTypeDef,
    WithdrawByoipCidrResponseTypeDef,
)

def get_structure() -> AcceleratorAttributesTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-globalaccelerator` version is the same as related `boto3` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-globalaccelerator docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_globalaccelerator/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
